rm(list=ls())

library(data.table)
library(xts)
library(viridis)
library(ppcor)
library(corrplot)
library(igraph)

### read data 
defs=fread("data/defs.txt",dec=".",sep="\t") # definitions of series
prices=fread("data/prices.txt",dec=".",sep="\t") # read prices 
prices=xts(prices[,-1],order.by=as.Date(prices$date)) # convert them to time series
returns=diff(prices,lag=1,log=TRUE,na.pad=FALSE) # calculate returns
returns=as.data.frame(returns)

### read data mp
returns=returns[,c("Esp500","Eftse","Epacific","BtreasLong","BtreasShort","RealEstate")]
par(mfrow=c(1,2))
mcor=cor(returns)
corrplot(mcor,method="color",type="upper",
                   order="hclust",addCoef.col ="black",
                   diag=F)
mpcor=pcor(returns)$estimate
rownames(mpcor)=names(returns); colnames(mpcor)=names(returns)
corrplot(mpcor,method="color",type="upper",
         order="hclust",addCoef.col ="black",
         diag=F)

tmp=mcor
tmp[cor.mtest(mcor)$p>0.01]=0
rownames(mpcor)=names(returns); colnames(mpcor)=names(returns)
plot(graph_from_adjacency_matrix(abs(sign(tmp)),mode="undirected",diag=F))
tmp=mpcor
tmp[pcor(returns)$p.value>0.01]=0
rownames(mpcor)=names(returns); colnames(mpcor)=names(returns)
plot(graph_from_adjacency_matrix(abs(sign(tmp)),mode="undirected",diag=F))

  
